package org.freecompany.infoset;

import static org.freecompany.infoset.InfosetFactory.Registry.lookup;

public abstract class AbstractInfoset< T> implements Infoset< T> {

	protected final Class< T> type;
	protected final InfosetFactory< T> factory;

	public AbstractInfoset( final Class< T> type) {
		this( type, lookup( type));
	}

	public AbstractInfoset( final Class< T> type, final InfosetFactory< T> factory) {
		this.type = type;
		this.factory = factory;
	}

	public Class< T> getType() {
		return type;
	}

	public InfosetFactory< T> getFactory() {
		return factory;
	}
}
