package org.freecompany.infoset;

import java.util.Iterator;
import java.util.List;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPathFunction;
import javax.xml.xpath.XPathFunctionException;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class AggregateFunction implements XPathFunction {

	public Object evaluate( List args) throws XPathFunctionException {
		Document document;
		try {
			document = DocumentBuilderFactory.newInstance().newDocumentBuilder().newDocument();
		} catch ( ParserConfigurationException e) {
			throw new XPathFunctionException( e);
		}
		
		if ( args.size() < 2) throw new XPathFunctionException( "Function 'aggregate' requires at least two arguments.");
		
		final Iterator i = args.iterator();
		final Node root = document.createElement((  String) i.next());
		document.appendChild( root);
		while ( i.hasNext()) {
			final NodeList list = ( NodeList) i.next();
			for ( int x = 0; x < list.getLength(); x++) root.appendChild( document.importNode( list.item( x), true)); 
		}
		return document;
	}
}
