package org.freecompany.infoset;

import static org.freecompany.infoset.InfosetFactory.Registry.lookup;

public class ContentReference< T> implements Reference< T> {

	protected final Infoset< T> content;

	public ContentReference( final T content) {
		this.content = workaround( content);
	}

	@SuppressWarnings( "unchecked")
	protected < V> Infoset< V> workaround( final V content) {
		final Class< V> clazz = ( Class< V>) content.getClass();
		return new DefaultInfoset< V>( clazz, lookup( clazz), content);
	}

	public Infoset< T> infoset() {
		return content;
	}

	public boolean resolved() { return true; }

	@Override
	public String toString() {
		return content.toString();
	}
}
