package org.freecompany.infoset;

public class PointerReference< T> implements Reference< T> {

	protected final Reference< T> reference;

	public PointerReference( final Reference< T> reference) {
		this.reference = reference;
	}

	public Infoset< T> infoset() throws ReferenceException {
		return reference.infoset();
	}

	public boolean resolved() {
		return reference.resolved();
	}

	@Override
	public String toString() {
		return "Pointer[ " + reference + "]";
	}
}
