package org.freecompany.infoset;

import java.io.IOException;
import java.net.URI;
import java.net.MalformedURLException;

public class UriReference< T> extends AbstractReference< T> {

	protected final InfosetFactory< T> factory;
	protected final URI uri;
	protected Infoset< T> infoset;

	public UriReference( final InfosetFactory< T> factory, final URI uri) {
		this.factory = factory;
		this.uri = uri;
	}

	public Infoset< T> infoset() throws ReferenceException {
		synchronized ( this) {
			if ( infoset == null) {
				try {
					infoset = factory.create( uri.toURL());
				} catch ( MalformedURLException e) {
					throw new ReferenceException( e);
				} catch ( IllegalArgumentException e) {
					throw new ReferenceException( e);
				} catch ( IOException e) {
					throw new ReferenceException( e);
				}
			}
		}
		return infoset;
	}

	public String toString() {
		return uri.toString();
	}
}
