package org.freecompany.infoset.sax;

import org.freecompany.infoset.AbstractInfoset;
import org.freecompany.infoset.Infoset;
import org.freecompany.infoset.InfosetFactory;
import org.freecompany.util.xml.dom2sax.Dom2Sax;
import org.w3c.dom.Document;
import org.xml.sax.ContentHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.ext.LexicalHandler;
import org.xml.sax.helpers.XMLFilterImpl;

public class DomWrapperInfoset extends AbstractInfoset< XMLReader> {

	protected Infoset< Document> infoset;

	public DomWrapperInfoset( final InfosetFactory< XMLReader> factory, final Infoset< Document> infoset) {
		super( XMLReader.class, factory);
		this.infoset = infoset;
	}
	
	public XMLReader get() {
		return new XMLFilterImpl() {
			private final Dom2Sax converter = new Dom2Sax();
			public void setLexicalHandler( final LexicalHandler handler) { converter.setLexicalHandler( handler); }
			
			@Override
			public void setContentHandler( final ContentHandler handler) { converter.setContentHandler( handler); }
			
			@Override
			public void parse( String id) throws SAXException { parse(( InputSource) null); }
			
			@Override
			public void parse( InputSource source) throws SAXException { converter.convert( infoset.get()); }
		};
	}
}
